\NeedsTeXFormat {LaTeX2e}
\ProvidesPackage {chato-notations}[2022-08-27 v0.1]

%% Ensembles, intervalles
\NewDocumentCommand\genint{mmmmm}{\mathord{\left#1#4\mathbin{#3}#5\right#2}}
%% ir = intervalle de réels ; f = fermé, o = ouvert
\NewDocumentCommand\irff{}{\genint[],}
\NewDocumentCommand\irfo{}{\genint[[,}
\NewDocumentCommand\iroo{}{\genint][,}
\NewDocumentCommand\irof{}{\genint]],}
%% ii = intervalle d'entiers (int)
\NewDocumentCommand\iiff{}{\genint\llbracket\rrbracket,}
\NewDocumentCommand\iifo{}{\genint\llbracket\llbracket,}
\NewDocumentCommand\iioo{}{\genint\rrbracket\llbracket,}
\NewDocumentCommand\iiof{}{\genint\rrbracket\rrbracket,}

\NewDocumentCommand{\enstq}{mm}{\left\{#1 \,\middle\vert\, #2\right\}}

\NewDocumentCommand{\abs}{m}{\left|#1 \right|}

% Parties entières
\NewDocumentCommand{\floor}{m}{\left\lfloor #1\right\rfloor}
\NewDocumentCommand{\ceil}{m}{\left\lceil #1\right\rceil}

\NewDocumentCommand{\Z}{}{\ensuremath{\mathbb Z}}
\NewDocumentCommand{\Q}{}{\ensuremath{\mathbb Q}}
\NewDocumentCommand{\N}{}{\ensuremath{\mathbb N}}
\NewDocumentCommand{\R}{}{\ensuremath{\mathbb R}}

\NewDocumentCommand\prive{}{\setminus}

\RequirePackage{newunicodechar}
\newunicodechar{…}{\dots}

\let\textdef\textit
\let\textterm\texttt

\AddToHook{begindocument/end}{%
\NewDocumentCommand\lequiv{}{\mathrel{\mathord\models\reflectbox{$\models$}}}
\let\oldvdash\vdash
\RenewDocumentCommand{\vdash}{o}{\mathrel{\oldvdash\IfValueT{#1}{_{\kern-5pt\hbox to4pt{\tiny\hss$#1$\hss}}}}}
\NewDocumentCommand{\notvdash}{o}{\mathrel{\notaccent\oldvdash\IfValueT{#1}{_{\kern-5pt\hbox to4pt{\tiny\hss$#1$\hss}}}}}
\@ifpackageloaded{unicode-math}%
  {\NewNegationCommand\models{\mathrel{\notaccent\models}}%
  }
%else  
  {\def\notmodels{\not\models}%
%
  }
}

\usepackage{bussproofs}

\ExplSyntaxOn
\prg_new_conditional:Nnn \chato_notations__if_beamer_loaded: { T }
 {
  \@ifpackageloaded { beamerarticle } { \prg_return_true: } { \@ifclassloaded { beamer } { \prg_return_true: } { \prg_return_false:} }
 }

\AtBeginDocument{%
\chato_notations__if_beamer_loaded:T
{
\let\ysorigRightLabel\RightLabel
\let\ysorigUnaryInfC\UnaryInfC
\let\ysorigBinaryInfC\BinaryInfC
\let\ysorigTrinaryInfC\TrinaryInfC
\let\ysorigAxiomC\AxiomC

\NewDocumentCommand\invisLine{r<>}{\gdef\buildScore{\buildInvisibleScore}\only<article:0|handout:0|#1>{\gdef\buildScore{\buildSingleScore}}\ignorespaces}


\RenewDocumentCommand\RightLabel{d<>m}{\IfValueTF{#1}{\ysorigRightLabel{\placehold<#1>{\scriptsize #2}}}{\ysorigRightLabel{\scriptsize #2}}}
\RenewDocumentCommand\UnaryInfC{d<>m}{\IfValueTF{#1}{\invisLine<#1>\ysorigUnaryInfC{\placehold<#1>{#2}}}{\ysorigUnaryInfC{#2}}}
\RenewDocumentCommand\BinaryInfC{d<>m}{\IfValueTF{#1}{\invisLine<#1>\ysorigBinaryInfC{\placehold<#1>{#2}}}{\ysorigBinaryInfC{#2}}}
\RenewDocumentCommand\TrinaryInfC{d<>m}{\IfValueTF{#1}{\invisLine<#1>\ysorigTrinaryInfC{\placehold<#1>{#2}}}{\ysorigTrinaryInfC{#2}}}
\RenewDocumentCommand\AxiomC{d<>m}{\IfValueTF{#1}{\invisLine<#1>\ysorigAxiomC{\placehold<#1>{#2}}}{\ysorigAxiomC{#2}}}


\def\buildInvisibleScore{%
    \displace=\curScoreEnd%
    \advance \displace by -\curScoreStart%
    \global\setbox \myBoxD =%
        \hbox to \displace{\vbox{\vskip.4pt}}%
}
}
}
\ExplSyntaxOff